﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RimWorld;
using Verse;
using UnityEngine;

namespace SmokingGun
{
    public class Verb_ShootWithSmoke : Verb_Shoot
    {
        private const float MEHNI_DECIDED_ON_MAGIC_NUMBER = 32f; //make this bigger to make motes smaller. Scales with damage.

        protected override bool TryCastShot()
        {
            if (base.TryCastShot())
            {
                Vector3 position = this.caster.PositionHeld.ToVector3();
                Map mapHeld = this.caster.MapHeld;
                float scale = (float) Mathf.Clamp01(this.GetProjectile()?.projectile?.GetDamageAmount(this.caster) /
                                                    MEHNI_DECIDED_ON_MAGIC_NUMBER ?? 1f);

                //throwing two for thickness.
                MoteMaker2.ThrowFlintLockSmoke(position, mapHeld, scale);
                MoteMaker2.ThrowFlintLockSmoke(position, mapHeld, scale);

                return true;
            }

            return false;
        }
    }

    [DefOf]
    public static class GrimworldMoteDefOf
    {
        // ReSharper disable once InconsistentNaming
        public static ThingDef Grimworld_FlintlockSmoke;
    }

    public static class MoteMaker2
    {
        //exactly the same as ThrowSmoke, but using a different MoteDef instead. This to expose the mote to XML.
        public static void ThrowFlintLockSmoke(Vector3 loc, Map map, float size)
        {
            if (!loc.ShouldSpawnMotesAt(map) || map.moteCounter.SaturatedLowPriority)
            {
                return;
            }
            MoteThrown moteThrown = (MoteThrown)ThingMaker.MakeThing(GrimworldMoteDefOf.Grimworld_FlintlockSmoke);
            moteThrown.Scale         = Rand.Range(1.5f, 2.5f) * size;
            moteThrown.rotationRate  = Rand.Range(-30f, 30f);
            moteThrown.exactPosition = loc;
            moteThrown.SetVelocity(Rand.Range(30, 40), Rand.Range(0.5f, 0.7f));
            GenSpawn.Spawn(moteThrown, loc.ToIntVec3(), map);
        }
    }
}
